
import config
from lib.mvc.view import View
from lib.mvc.widgets import *

class AreaView(View, ):
    def _init_(self):
        self.setWidget(newHBox(False, 0))
        self._expenseArea = newEventBox(name='expense_area')
        self.add(self._expenseArea)
        self.getWidget().pack_start(self._expenseArea, expand=True, fill=True)
        addButton = newFingerButton(label='Add Expense', usize=(((327 - 10) - 10), 70))
        self.add(addButton, 'add_button')
        vbox = newVBox(False, 0)
        self._padButton = pad(addButton, 10, 10, 13, 0)
        vbox.pack_start(self._padButton, fill=True, expand=False)
        self._detailArea = newEventBox(name='detail_area')
        self.add(self._detailArea)
        vbox.pack_start(self._detailArea, expand=True, fill=True)
        self.getWidget().pack_start(vbox, expand=True, fill=True)
    def fillExpenseArea(self, widget, show=True):
        child = self._expenseArea.get_child()
        if child:
            self._expenseArea.remove(child)
        self._expenseArea.add(widget)
        if show:
            self._expenseArea.show_all()
    def fillDetailArea(self, widget, show=True, show_all=False):
        child = self._detailArea.get_child()
        if child:
            self._detailArea.remove(child)
        self._detailArea.add(widget)
        if show:
            if show_all:
                self._detailArea.show_all()
            else:
                self._detailArea.show()
    def showExpenseArea(self):
        self._expenseArea.show_all()
        self._padButton.set_padding(10, 10, 0, 13)
    def showDetailArea(self):
        self._detailArea.show()
        self._padButton.show_all()
    def hideDetailArea(self):
        self._detailArea.hide_all()
    def hideExpenseArea(self):
        self._expenseArea.hide_all()
        self._padButton.set_padding(10, 10, 10, 13)

class Empty(gtk.Alignment, ):
    def __init__(self):
        gtk.Alignment.__init__(self, 0.5, 0.5, 1.0, 1.0)
        self.set_name('area_empty')
        self._vBox = newVBox()
        self.add(self._vBox)
        self._init_()
    def _init_(self):
        pass

class EmptyStart(Empty, ):
    ARROW = 'data/img/ToshlArrow.png'
    def _init_(self):
        image = newImage(from_file=config.joinRoot(self.ARROW))
        self._vBox.pack_start(image, expand=False, fill=False, padding=20)
        self._vBox.pack_start(newLabel(markup='Tap <b>Add Expense</b> to', name='empty_font'), expand=False, fill=False)
        self._vBox.pack_start(newLabel(markup='start using the app', name='empty_font'), expand=False, fill=False)

class EmptyTimespan(Empty, ):
    def _init_(self):
        self._vBox.pack_start(newLabel(size_request=(-1, 100)), expand=False)
        self._vBox.pack_start(newLabel(text='There are no expenses in', name='empty_font'), expand=False)
        self._timespanLabel = newLabel(text='selected timespan (last month)', name='empty_font')
        self._vBox.pack_start(self._timespanLabel, expand=False)
        self._vBox.pack_start(newLabel(), expand=True)
    def setTimespan(self, string):
        self._timespanLabel.set_text(('selected timespan (%s)' % string))
