
import logging
import gobject, gtk
import threading, thread

class Task(object, ):
    def __init__(self, func, loopcb=None, endcb=None):
        self.func = func
        self.endcb = endcb
        self.loopcb = (loopcb if loopcb else self.nothin)
        self._thread = None
    def _exec(self, *args, **kwargs):
        noloop = False
        if ('noloop' in kwargs):
            noloop = True
            del kwargs['noloop']
        self._ended = False
        if noloop:
            self.func(*args, **kwargs)
        else:
            for result in self.func(*args, **kwargs):
                if self._ended:
                    thread.exit()
                gobject.idle_add(self._loop, result)
        if (self.endcb is not None):
            gobject.idle_add(self.endcb)
    def _loop(self, result):
        if (result is None):
            result = ()
        if not(isinstance(result, tuple)):
            result = (result,)
        self.loopcb(*result)
    def start(self, *args, **kwargs):
        threading.Thread(target=self._exec, args=args, kwargs=kwargs).start()
    def stop(self):
        self._ended = True
    def nothin(self, *args):
        pass
